accounts/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path
from .views import signupform

urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signupform, name="signup"),
]

projects/urls.py
from django.urls import path
from projects.views import (
    ProjectListView,
    ProjectDetailView,
    ProjectCreateView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path
from django.urls import include
from django.urls import reverse_lazy
from django.views.generic.base import RedirectView


urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
    path("accounts/", include("accounts.urls")),
]

accounts/models.py
# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models
from projects.models import Project
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL
# Create your models here.


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField()
    project = models.ForeignKey(
        Project, related_name="tasks", on_delete=models.CASCADE, null=True
    )
    assignee = models.ForeignKey(
        USER_MODEL,
        related_name="tasks",
        on_delete=models.CASCADE,
        null=True,
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth import login


# Create your views here.


def signupform(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST.get("username")
            password = request.POST.get("password")
            user = User.objects.create_user(
                username=username, password=password
            )
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()
    return render(request, "registration/signup.html", {"form": form})

projects/views.py
from django.views.generic.list import ListView
from projects.models import Project
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView

# Create your views here.


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list_projects.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"


class ProjectCreateView(CreateView):
    model = Project
    template_name = "projects/new.html"
    fields = ["name", "description", "members"]

tasks/views.py
from django.views.generic.edit import CreateView
from tasks.models import Task
from django.urls import reverse_lazy


# Create your views here.


class TaskCreateView(CreateView):
    model = Task
    template_name = "tasks/new.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]
    success_url = reverse_lazy("show_project")

accounts/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>New Recipe - Scrumptious</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}">
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    <li>
                        <a href="{% url 'home' %}">My Projects</a>
                    </li>

                    <li>
                        <a href="{% url 'create_project' %}">Create</a>
                    </li>
                    <li>
                        <a href="{% url 'signup' %}">Register</a>
                    </li>
                    {% if user.is_staff %}
                        <li>
                            <a href="{% url 'admin:index' %}">Admin</a>
                        </li>
                    {% endif %}
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
            {% block content %}
            {% endblock content %}
        </header>
    </body>
</html>

projects/templates/projects/detail.html
{% extends "base.html" %}
{% block content %}
    <main>
        <div>
            <h1>{{ project.name }}</h1>
            <p>{{ project.description }}</p>
            <h2>Tasks</h2>

        </div>
        <table>
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Assignee</th>
                    <th>Start date</th>
                    <th>Due date</th>
                    <th>Is completed</th>
                </tr>
            </thead>
            <tbody>
                {% for task in show_project %}
                <tr>
                    <td>{{ task.name }}</td>
                    <td>{{ task.assignee }}</td>
                    <td>{{ task.due_date }}</td>
                    <td>{{ task.is_compelted }}</td>
                </tr>
                {% endfor %}
            </tbody>
        </table>
    </main>
 {% endblock content %}

projects/templates/projects/list_projects.html
{% extends "base.html" %}
{% block content %}
    <main>
        <div>
            <h1>My Projects</h1>
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Number of Tasks</th>
                    </tr>
                </thead>
                <tbody>
                    {% for project in project_list %}
                        <tr>
                            <td>
                                <a href="{% url 'show_project' project.pk %}">{{ project.name }}</a>
                            </td>
                            <td>{{ project.projects.all|length }}</td>
                        {% empty %}
                            <p>You are not assigned to any projects</p>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        </div>
    </main>
{% endblock content %}

projects/templates/projects/new.html
{% extends "base.html" %}

{% block content %}
<main>
    <div>
        <h1>Create a New Project</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div>
              <button>Create</button>
            </div>
          </form>
    </div>
  </main>
{% endblock content %}